/* ************************************************************************** */
/** Descriptive File Name

  @Company
    Company Name

  @File Name
    filename.h

  @Summary
    Brief description of the file.

  @Description
    Describe the purpose of this file.
 */
/* ************************************************************************** */
#ifndef _APP_H
#define	_APP_H

#include "device.h"
#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>

#include "string.h"
#include "definitions.h"


#define SYMM_SLOT       0x03
#define MAC_MODE        0x00
#define MAC_OPCODE      0x08
#define PACKET_SIZE     39
#define RESPONSE_SIZE   35

#define I2C_ADDR    (0x31)
#define SWI_ADDR  (0x62)

typedef enum
{
    CR_INIT_APP,
    CR_SEND_CHALLENGE,
    CR_VERIFY_RESPONSE,
    CR_DONE
} APP_STATE;

typedef enum {
  ATCA_SUCCESS = 0x00, ATCA_CONFIG_ZONE_LOCKED = 0x01, ATCA_DATA_ZONE_LOCKED = 0x02, ATCA_INVALID_POINTER,
  ATCA_INVALID_LENGTH, ATCA_WAKE_FAILED = 0xD0, ATCA_CHECKMAC_VERIFY_FAILED = 0xD1, ATCA_PARSE_ERROR = 0xD2,
  ATCA_STATUS_CRC = 0xD4, ATCA_STATUS_UNKNOWN = 0xD5, ATCA_STATUS_ECC = 0xD6, ATCA_STATUS_SELFTEST_ERROR = 0xD7,
  ATCA_FUNC_FAIL = 0xE0, ATCA_GEN_FAIL = 0xE1, ATCA_BAD_PARAM = 0xE2, ATCA_INVALID_ID = 0xE3,
  ATCA_INVALID_SIZE = 0xE4, ATCA_RX_CRC_ERROR = 0xE5, ATCA_RX_FAIL = 0xE6, ATCA_RX_NO_RESPONSE = 0xE7,
  ATCA_RESYNC_WITH_WAKEUP = 0xE8, ATCA_PARITY_ERROR = 0xE9, ATCA_TX_TIMEOUT = 0xEA, ATCA_RX_TIMEOUT = 0xEB,
  ATCA_TOO_MANY_COMM_RETRIES = 0xEC, ATCA_SMALL_BUFFER = 0xED, ATCA_COMM_FAIL = 0xF0, ATCA_TIMEOUT = 0xF1,
  ATCA_BAD_OPCODE = 0xF2, ATCA_WAKE_SUCCESS = 0xF3, ATCA_EXECUTION_ERROR = 0xF4, ATCA_UNIMPLEMENTED = 0xF5,
  ATCA_ASSERT_FAILURE = 0xF6, ATCA_TX_FAIL = 0xF7, ATCA_NOT_LOCKED = 0xF8, ATCA_NO_DEVICES = 0xF9,
  ATCA_HEALTH_TEST_ERROR = 0xFA, ATCA_ALLOC_FAILURE = 0xFB, ATCA_USE_FLAGS_CONSUMED = 0xFC, ATCA_NOT_INITIALIZED = 0xFD
} RESPONSE;

int cr_app(void);

#endif	/* APP_HEADER */
